## dolfin 1.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for DOLFIN

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFIN)
set(DOLFIN_VERSION_MAJOR "1")
set(DOLFIN_VERSION_MINOR "0")
set(DOLFIN_VERSION_MICRO "rc2")
set(DOLFIN_VERSION "${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR}.${DOLFIN_VERSION_MICRO}")

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 OLD)
endif()

# Set location of our FindFoo.cmake modules
set(DOLFIN_CMAKE_DIR "${DOLFIN_SOURCE_DIR}/cmake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH "${DOLFIN_CMAKE_DIR}/modules")

# Make sure CMake uses the correct dolfin-config.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfin)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

option(BUILD_SHARED_LIBS "Build DOLFIN with shared libraries." ON)
option(CMAKE_SKIP_RPATH "Do not add runtime paths when using shared libraries." OFF)
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(DOLFIN_DEBUG_UBLAS "Use extra uBLAS debugging." OFF)
option(DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage." OFF)
option(DOLFIN_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(DOLFIN_ENABLE_UNIT_TESTS "Enable unit tests." ON)
option(DOLFIN_ENABLE_TESTING "Enable testing." OFF)
option(DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs." OFF)
option(DOLFIN_ENABLE_DOCS "Enable generation of documentation." ON)

#option(CMAKE_SKIP_RPATH "Do not add runtime paths when using shared libraries." ON)

#------------------------------------------------------------------------------
# Enable or disable optional packages

# FIXME: Discuss which should be enabled by default
# FIXME: AL: I suggest only the Python wrappers
# FIXME: GNW: That would lead to most demos failing (no LU solver)
# FIXME: GNW: I suggest enabling everything, but using QUIET to eliminate
#             excessive output
# FIXME: JR: What about adopting the way they do this in Trilinos? Then we
#            could have options like DOLFIN_ENABLE_ALL_PACKAGES for enabling
#            everything and DOLFIN_ENABLE_DEFAULT_PACKAGES for enabling only
#            some default packages.

# List optional packages
set(OPTIONAL_PACKAGES "")
list(APPEND OPTIONAL_PACKAGES "OpenMP")
list(APPEND OPTIONAL_PACKAGES "MPI")
list(APPEND OPTIONAL_PACKAGES "PETSc")
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "Trilinos")
list(APPEND OPTIONAL_PACKAGES "MTL4")
list(APPEND OPTIONAL_PACKAGES "UMFPACK")
list(APPEND OPTIONAL_PACKAGES "CHOLMOD")
list(APPEND OPTIONAL_PACKAGES "SCOTCH")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "GMP")
list(APPEND OPTIONAL_PACKAGES "CGAL")
list(APPEND OPTIONAL_PACKAGES "zlib")
#list(APPEND OPTIONAL_PACKAGES "HDF5")
list(APPEND OPTIONAL_PACKAGES "Python")
list(APPEND OPTIONAL_PACKAGES "Sphinx")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFIN_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  if (${OPTION_NAME} MATCHES "GMP")
    option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." OFF)
  else()
    option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
  endif()
endforeach()

#------------------------------------------------------------------------------
# Package-specific options

option(CGAL_DISABLE_ROUNDING_MATH_CHECK "Disable rounding math check in CGAL. This permits Valgrind to run." OFF)

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-pipe ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wall -Werror -pedantic ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Disable strict checks that fail for inlcuded 3rd party libraries
CHECK_CXX_COMPILER_FLAG(-Wno-long-long HAVE_DISABLE_PEDANTIC_CHECKS)
if (HAVE_DISABLE_PEDANTIC_CHECKS)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wno-long-long ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-std=c++98 HAVE_STD)
if (HAVE_STD)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-std=c++98 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-g ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-O2 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${DOLFIN_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Do not debug uBLAS unless requested
if (NOT DOLFIN_DEBUG_UBLAS)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DBOOST_UBLAS_NDEBUG")
endif()

# FIXME: Do we want to add -DDEBUG to RelWithDebInfo?

# Add debug definitions
if (CMAKE_BUILD_TYPE STREQUAL "Developer" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DDEBUG")
endif()

# Add flags for generating code coverage reports
if (DOLFIN_ENABLE_CODE_COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

#------------------------------------------------------------------------------
# Check for MPI and OpenMP

# FIXME: Should be set CMake to use the MPI compiler wrappers?

if (DOLFIN_ENABLE_MPI)
  find_package(MPI)
endif()

if (DOLFIN_ENABLE_OPENMP)
  find_package(OpenMP)
  include(CheckOpenMP)
  check_openmp_unsigned_int_loop_control_variable(OPENMP_UINT_TEST_RUNS)
  if (NOT OPENMP_UINT_TEST_RUNS)
    set(OPENMP_FOUND FALSE)
  endif()
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

# Check for Boost
set(BOOST_ROOT $ENV{BOOST_DIR})
set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
set(Boost_ADDITIONAL_VERSIONS 1.43 1.43.0 1.44 1.44.0 1.45 1.45.0 1.46 1.46.0 1.46.1 1.47 1.47.0)

if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  find_package(Boost 1.36 COMPONENTS filesystem program_options system thread iostreams math_tr1 mpi serialization REQUIRED)
else()
  find_package(Boost 1.36 COMPONENTS filesystem program_options system thread iostreams math_tr1 REQUIRED)
endif()

# Check for required packages
find_package(UFC 2.0.2 QUIET HINTS ${UFC_DIR})
if (NOT UFC_FOUND)
  message(FATAL_ERROR "Could not find a configuration file for package UFC that is "
    "compatible with requested version 2.0.2.\n"
    "Set UFC_DIR to the directory containing a CMake configuration file for UFC.")
else()
  message(STATUS "UFC version: ${UFC_VERSION_STRING}")
endif()

find_package(Armadillo REQUIRED)
find_package(LibXml2 REQUIRED)

#------------------------------------------------------------------------------
# Run tests to find optional packages

# Note: Check for Python interpreter even when Python is disabled because it
#       is used to get the installation path for dolfin_utils
find_package(PythonInterp)
if (DOLFIN_ENABLE_PYTHON)
  find_package(PythonLibs)

  # If Python is found, check for NumPy and SWIG
  if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
    find_package(NumPy REQUIRED)

    # This is to help pick up swig on Debian/Ubuntu. It can be removed
    # when Debian/Ubuntu rename swig2.0 -> swig
    find_program(SWIG_EXECUTABLE swig2.0)

    find_package(SWIG REQUIRED)
    if (${SWIG_VERSION} LESS 2.0)
      message(FATAL_ERROR " DOLFIN requires SWIG version 2.0 or greater. You have version ${SWIG_VERSION}. Set DOLFIN_ENABLE_PYTHON to False or install correct SWIG version.")
    endif()
    include(UseSWIG)
    set(PYTHON_FOUND TRUE)
  endif()

endif()

# Check for ParMETIS and SCOTCH
if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  if (DOLFIN_ENABLE_PARMETIS)
    find_package(ParMETIS)
  endif()

  if (DOLFIN_ENABLE_SCOTCH)
    find_package(ScotchPT)
  endif()
endif()

# Check for UMFPACK
if (DOLFIN_ENABLE_UMFPACK)
  find_package(AMD)
  find_package(BLAS)
  find_package(UMFPACK)
endif()

# Check for CHOLMOD
if (DOLFIN_ENABLE_CHOLMOD)
  find_package(CHOLMOD)
endif()

# Check for Trilinos and the requires Trilinos packages
if (DOLFIN_ENABLE_TRILINOS)
  message(STATUS "Checking for Trilinos")
  find_package(Trilinos 10.8.1 PATHS ${TRILINOS_DIR} ${Trilinos_DIR} $ENV{TRILINOS_DIR} QUIET)
  set(DOLFIN_TRILINOS_PACKAGES "Epetra;Zoltan;ML;Ifpack;Amesos")

  # Check for required packages
  set(DOLFIN_TRILINOS_PACKAGES_FOUND false)
  if (Trilinos_FOUND)
    message(STATUS "  Trilinos version ${Trilinos_VERSION} found. Checking for components")

    # Check for packages
    set(DOLFIN_TRILINOS_PACKAGES_FOUND true)
    foreach (package ${DOLFIN_TRILINOS_PACKAGES})
      find_package(${package} PATHS $ENV{TRILINOS_DIR} QUIET)
      if (NOT ${package}_FOUND)
        set(DOLFIN_TRILINOS_PACKAGES_FOUND false)
      endif()
    endforeach()

    if (DOLFIN_TRILINOS_PACKAGES_FOUND)
      message(STATUS "  All necessary Trilinos components found. Trilinos will be enabled")
      set(DOLFIN_TRILINOS_DEFINITIONS)

      # Loop over each package
      foreach (package ${DOLFIN_TRILINOS_PACKAGES})
        # Loop over libs and get full path
        foreach (lib ${${package}_LIBRARIES})
          find_library(TRILINOS_LIB_${lib} ${lib} HINTS ${${package}_LIBRARY_DIRS})
          if (TRILINOS_LIB_${lib})
            list(APPEND DOLFIN_TRILINOS_LIBRARIES ${TRILINOS_LIB_${lib}})
          endif()
        endforeach()
      endforeach()

      # Remove duplicates
      list(REVERSE DOLFIN_TRILINOS_LIBRARIES)
      list(REMOVE_DUPLICATES DOLFIN_TRILINOS_LIBRARIES)
      list(REVERSE DOLFIN_TRILINOS_LIBRARIES)

    else()
      message(STATUS "Trilinos found, but some required components are missing.")
      foreach (package ${DOLFIN_TRILINOS_PACKAGES})
        message(STATUS "  ${package}: ${${package}_FOUND}")
      endforeach()
    endif()

  else()
    message(STATUS "Trilinos could not be found")
  endif()
endif()

# Check for MTL4
if (DOLFIN_ENABLE_MTL4)
  find_package(MTL4)
endif()

# Check for PETSc and SLEPc
if (DOLFIN_ENABLE_PETSC)
  find_package(PETSc)
  if (PETSC_FOUND AND DOLFIN_ENABLE_SLEPC)
    find_package(SLEPc)
  endif()
endif()

# Check for CGAL
if (DOLFIN_ENABLE_CGAL)
  find_package(CGAL)
endif()

# Check for zlib
if (DOLFIN_ENABLE_ZLIB)
  find_package(ZLIB)
endif()

# Check for cppunit
if (DOLFIN_ENABLE_UNIT_TESTS)
  find_package(CppUnit)
endif()

# Check for Sphinx
if (DOLFIN_ENABLE_DOCS AND PYTHON_FOUND)
  find_package(Sphinx 1.0.7)
endif()

#------------------------------------------------------------------------------
# Print summary of found and not found optional packages

# FIXME: Use FeatureSummary.cmake to do this

# Gather information about which optional packages were found and not found
set(OPTIONAL_PACKAGES_FOUND "")
set(OPTIONAL_PACKAGES_NOT_FOUND "")
set(OPTIONAL_PACKAGES_NOT_ENABLED "")
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "${OPTIONAL_PACKAGE}" PKG)
  if (${PKG}_FOUND OR ${OPTIONAL_PACKAGE}_FOUND)

=== doc/CMakeLists.txt ===
project(dolfin-doc)

message(STATUS "Enabling generation of documentation.")

# Copy most of doc directory to build directory
file(COPY . DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
  FILES_MATCHING
  PATTERN "*.rst"
  PATTERN "*.py"
  PATTERN "*.conf"
  PATTERN "*.html"
  PATTERN "*.png"
  PATTERN "*.css*"
  PATTERN "Makefile"
  PATTERN "CMakeFiles" EXCLUDE)

# Set directories for where sphinx projects and their source
# directories are located
set(DOLFIN_CPP_SPHINX_DIR "sphinx-cpp")
set(DOLFIN_CPP_SPHINX_SOURCE_DIR "${DOLFIN_CPP_SPHINX_DIR}/source")
set(DOLFIN_PYTHON_SPHINX_DIR "sphinx-python")
set(DOLFIN_PYTHON_SPHINX_SOURCE_DIR "${DOLFIN_PYTHON_SPHINX_DIR}/source")

# Initialize separate cpp and python projects
message(STATUS "Initializing sphinx projects")

file(COPY "${CMAKE_CURRENT_BINARY_DIR}/sphinx-common/"
  DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_CPP_SPHINX_DIR}")
file(COPY "${CMAKE_CURRENT_BINARY_DIR}/sphinx-common/"
  DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_PYTHON_SPHINX_DIR}")

execute_process(COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/generate_main_index.py" "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_CPP_SPHINX_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_PYTHON_SPHINX_SOURCE_DIR}" "${DOLFIN_VERSION}")

# Add target doc_api: generate reST files from code for cpp and
# python. This takes a while.
add_custom_target(doc_api
  COMMAND ${PYTHON_EXECUTABLE} generate_api_doc.py
    "${DOLFIN_SOURCE_DIR}" api "${DOLFIN_VERSION}"
  COMMAND ${CMAKE_COMMAND} -E copy_directory
    api/cpp/programmers-reference
    "${DOLFIN_CPP_SPHINX_SOURCE_DIR}/programmers-reference"
  COMMAND ${CMAKE_COMMAND} -E copy_directory
    api/python/programmers-reference
    "${DOLFIN_PYTHON_SPHINX_SOURCE_DIR}/programmers-reference"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

# Add target doc_demo: copy demo code and doc files into sphinx
# projects and add additional index files.
add_custom_target(doc_demo
  COMMAND ${PYTHON_EXECUTABLE} copy_and_split_demo_doc.py
    "${DOLFIN_SOURCE_DIR}/demo"
    "${DOLFIN_CPP_SPHINX_SOURCE_DIR}/demo"
    "${DOLFIN_PYTHON_SPHINX_SOURCE_DIR}/demo"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

# Add target doc_html_[cpp|python]: run sphinx in [cpp|python] sphinx
# projects
if (SPHINX_FOUND)
  message(STATUS "Enabling generation of html-documentation")
  add_custom_target(doc_html_cpp
    COMMAND ${MAKE_PROGRAM} html
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_CPP_SPHINX_DIR}")

  add_custom_target(doc_html_python
    COMMAND ${MAKE_PROGRAM} html
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_PYTHON_SPHINX_DIR}")

  # Add target doc_html: run sphinx in both cpp and python
  add_custom_target(doc_html)
  add_dependencies(doc_html doc_html_cpp doc_html_python)

  # Add target doc_generate_all: Generate all doc (api and demos)
  add_custom_target(doc_generate_all)
  add_dependencies(doc_generate_all doc_demo doc_api)

  # FIXME: Want to run doc_generate_all before doc_html, but the order
  # of the targets is necessarily respected here.
  add_custom_target(doc)
  add_dependencies(doc doc_generate_all doc_html)

  # Add target: doc_install Copy generated sphinx projects to
  # DOLFIN_DOC_DIR
  add_custom_target(doc_install
    COMMAND ${CMAKE_COMMAND} -E copy_directory
      "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_CPP_SPHINX_DIR}"
      "${CMAKE_INSTALL_PREFIX}/${DOLFIN_DOC_DIR}/${DOLFIN_CPP_SPHINX_DIR}"
    COMMAND ${CMAKE_COMMAND} -E copy_directory
      "${CMAKE_CURRENT_BINARY_DIR}/${DOLFIN_PYTHON_SPHINX_DIR}"
      "${CMAKE_INSTALL_PREFIX}/${DOLFIN_DOC_DIR}/${DOLFIN_PYTHON_SPHINX_DIR}")
  add_dependencies(doc_install doc)

endif()

=== dolfin/CMakeLists.txt ===
set(DOLFIN_H dolfin.h)
install(FILES ${DOLFIN_H} DESTINATION ${DOLFIN_INCLUDE_DIR} COMPONENT Development)

#set(CMAKE_SKIP_BUILD_RPATH  FALSE)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

#------------------------------------------------------------------------------
# DOLFIN source directories

set(DOLFIN_DIRS
  adaptivity
  ale
  common
  fem
  function
  graph
  intersection
  io
  la
  log
  math
  mesh
  nls
  parameter
  plot
  quadrature
  refinement
  )

#------------------------------------------------------------------------------
# Install header files

foreach(DIR ${DOLFIN_DIRS})
  file(GLOB _HEADERS ${DIR}/*.h)
  list(APPEND HEADERS ${_HEADERS})
  install(FILES ${_HEADERS} DESTINATION ${DOLFIN_INCLUDE_DIR}/dolfin/${DIR} COMPONENT Development)

  file(GLOB _SOURCES ${DIR}/*.cpp)
  list(APPEND SOURCES ${_SOURCES})
endforeach()

#------------------------------------------------------------------------------
# Add include directories and libs of required packages

# libXml2
list(APPEND DOLFIN_INCLUDE_DIRECTORIES  ${LIBXML2_INCLUDE_DIR})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${LIBXML2_LIBRARIES})
list(APPEND DOLFIN_CXX_DEFINITIONS ${LIBXML2_DEFINITIONS})

# UFC
list(APPEND DOLFIN_INCLUDE_DIRECTORIES  ${UFC_INCLUDE_DIRS})

# Armadillo
list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${ARMADILLO_INCLUDE_DIRS})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${ARMADILLO_LIBRARIES})
list(APPEND DOLFIN_LINK_FLAGS ${ARMADILLO_LINK_FLAGS})

# Boost
list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIR})
list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${Boost_LIBRARIES})
list(APPEND APPEND DOLFIN_TARGET_LINK_LIBRARIES_DIRS ${Boost_LIBRARY_DIRS})

#------------------------------------------------------------------------------

# Trilinos
if (DOLFIN_ENABLE_TRILINOS AND TRILINOS_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_TRILINOS")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${TRILINOS_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${TRILINOS_LIBRARIES})
endif()

# SLEPC
if (DOLFIN_ENABLE_PETSC AND DOLFIN_ENABLE_SLEPC AND SLEPC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SLEPC")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${SLEPC_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${SLEPC_LIBRARIES})
endif()

# PETSc
if (DOLFIN_ENABLE_PETSC AND PETSC_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PETSC")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${PETSC_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${PETSC_LIBRARIES})
endif()

# MTL4
if (DOLFIN_ENABLE_MTL4 AND MTL4_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_MTL4")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${MTL4_DEFINITIONS})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MTL4_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${MTL4_LIBRARIES})
endif()

# UMFPACK
if (DOLFIN_ENABLE_UMFPACK AND UMFPACK_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_UMFPACK")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${UMFPACK_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${UMFPACK_LIBRARIES})
endif()

# CHOLMOD
if (DOLFIN_ENABLE_CHOLMOD AND CHOLMOD_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CHOLMOD")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CHOLMOD_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CHOLMOD_LIBRARIES})
endif()

# SCOTCH
if (DOLFIN_ENABLE_SCOTCH AND SCOTCH_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_SCOTCH")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${SCOTCH_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${SCOTCH_LIBRARIES})
endif()

# ParMETIS
if (DOLFIN_ENABLE_PARMETIS AND PARMETIS_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_PARMETIS")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${PARMETIS_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${PARMETIS_LIBRARIES})
endif()

# CGAL
if (DOLFIN_ENABLE_CGAL AND CGAL_FOUND)

  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CGAL")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CGAL_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CGAL_LIBRARIES})

  # Add -frounding-math if we have a GNU compiler
  if (CGAL_DISABLE_ROUNDING_MATH_CHECK)
    list(APPEND DOLFIN_CXX_DEFINITIONS "-DCGAL_DISABLE_ROUNDING_MATH_CHECK")
  else()
    if (CMAKE_COMPILER_IS_GNUCXX)
      set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} -frounding-math")
    endif()
  endif()

endif()

# GMP
if (DOLFIN_ENABLE_GMP AND GMP_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_GMP")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${GMP_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${GMP_LIBRARIES})
endif()

# ZLIB
if (DOLFIN_ENABLE_ZLIB AND ZLIB_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_ZLIB")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${ZLIB_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${ZLIB_LIBRARIES})
endif()

# HDF5
if (DOLFIN_ENABLE_HDF5 AND HDF5_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_HDF5")
  list(APPEND DOLFIN_CXX_DEFINITIONS ${HDF5_DEFINITIONS})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${HDF5_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${HDF5_LIBRARIES})
endif()

# CppUnit
if (DOLFIN_ENABLE_UNIT_TESTS AND CPPUNIT_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_CPPUNIT")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${CPPUNIT_INCLUDE_DIRS})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${CPPUNIT_LIBRARIES})
endif()

# MPI
if (DOLFIN_ENABLE_MPI AND MPI_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_MPI")
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MPI_INCLUDE_PATH})
  list(APPEND DOLFIN_TARGET_LINK_LIBRARIES ${MPI_LIBRARIES})
  list(APPEND DOLFIN_INCLUDE_DIRECTORIES ${MPI_INCLUDE_PATH})
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${MPI_COMPILE_FLAGS}")

  # FIXME: Is this linker flag required?
  #list(APPEND DOLFIN_LINK_FLAGS ${MPI_LINK_FLAGS})

  # Necessary flag for MPICH2
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DMPICH_IGNORE_CXX_SEEK")

endif()

# OpenMP
if (DOLFIN_ENABLE_OPENMP AND OPENMP_FOUND)
  list(APPEND DOLFIN_CXX_DEFINITIONS "-DHAS_OPENMP")
  set(DOLFIN_CXX_FLAGS "${DOLFIN_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

  if (MINGW)
    list(APPEND DOLFIN_LINK_FLAGS "${OpenMP_CXX_FLAGS}")
  endif()

endif()

#------------------------------------------------------------------------------
# Set compiler flags, include directories and library dependencies

# Add compiler include directories
include_directories(${DOLFIN_SOURCE_DIR} ${DOLFIN_INCLUDE_DIRECTORIES})

# Add CXX defintions
add_definitions(${DOLFIN_CXX_DEFINITIONS})
add_definitions(-DDOLFIN_VERSION="${DOLFIN_VERSION}")

# Add flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${DOLFIN_CXX_FLAGS}")

# Define libraries
add_library(dolfin ${DOLFIN_H} ${HEADERS} ${SOURCES})
set_target_properties(dolfin PROPERTIES ${DOLFIN_LIBRARY_PROPERTIES})

# FIXME: GNW: What link flags are we adding? Is this platform-independent?
# FIXME: JR: Yes, it is. Currently it is only '-framework vecLib' defined in
#            ARMADILLO_LINK_FLAGS but this variable will be empty on non-apple.
# FIXME: JR: Maybe we should add DOLFIN_LINK_FLAGS to CMAKE_SHARED_LINKER_FLAGS
#            instead of setting it as a property on the dolfin library? We
#            should at least add either CMAKE_SHARED_LINKER_FLAGS or
#            DOLFIN_LINK_FLAGS to dolfin-config.cmake.
# Add link flags (if any)
if (DOLFIN_LINK_FLAGS)
  set_target_properties(dolfin PROPERTIES LINK_FLAGS ${DOLFIN_LINK_FLAGS})
endif()

# Strip leading and trailing whitespaces
string(STRIP DOLFIN_TARGET_LINK_LIBRARIES "${DOLFIN_TARGET_LINK_LIBRARIES}")

# Add DOLFIN target libraries
target_link_libraries(dolfin ${DOLFIN_TARGET_LINK_LIBRARIES})

#------------------------------------------------------------------------------
# SWIG

if (PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND AND SWIG_FOUND)

  # Make sure we can import the UFC module and that it is compiled with present
  # version of SWIG
  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "from ufc import *; import sys; sys.stdout.write('.'.join([str(int(s)) for s in ufc.__swigversion__.split('.')]))"
    OUTPUT_VARIABLE UFC_SWIGVERSION
    RESULT_VARIABLE UFC_MODULE_NOT_FOUND
    )

  # Check that UFC can be imported
  if (UFC_MODULE_NOT_FOUND)
    message(WARNING "Unable to import UFC. Install latest UFC or check that PYTHONPATH is set appropriately. Python will be disabled.")
  endif()

  # Check that UFC was built with the version of SWIG that is being used
  if (NOT UFC_MODULE_NOT_FOUND AND (NOT "${SWIG_VERSION}" STREQUAL "${UFC_SWIGVERSION}"))
    message(WARNING "UFC compiled with different version of SWIG. Please install SWIG version ${UFC_SWIGVERSION} or recompile UFC with present SWIG.")
  endif()

  # If suitble UFC SWIG extension is found, add SWIG subdirectory
  if (NOT UFC_MODULE_NOT_FOUND AND ("${SWIG_VERSION}" STREQUAL "${UFC_SWIGVERSION}"))
    add_subdirectory(swig)
  endif()

endif()

#------------------------------------------------------------------------------
# Install

install(TARGETS dolfin
  RUNTIME DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${DOLFIN_LIB_DIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${DOLFIN_LIB_DIR} COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Define packages that should be required by pkg-config file
set(PKG_REQUIRES "ufc-1 libxml-2.0")

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${DOLFIN_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${DOLFIN_TARGET_LINK_LIBRARIES})
  string(REGEX REPLACE "(.?:?/[^ ]*)/lib([^ ]*)\\.(a|so|dylib|dll)" "-L\\1 -l\\2"
    _linkflags
    "${_lib}"
    )

  # Only add libraries that matches the form -L<libdir> -l<lib>
  if ("${_linkflags}" MATCHES "-L.+ -l.+")
    set(PKG_LINKFLAGS "${_linkflags} ${PKG_LINKFLAGS}")
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
foreach(_linkflag ${DOLFIN_LINK_FLAGS})
  set(PKG_LINK_FLAGS "${PKG_LINKFLAGS} ${_linkflag}")
endforeach()

# Configure and install pkg-config file
configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin.pc.in ${CMAKE_BINARY_DIR}/dolfin.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfin.pc
  DESTINATION ${DOLFIN_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Generate CMake config files (dolfin-config{,-version}.cmake)

# Set library location
get_target_property(DOLFIN_LIBRARY_LOCATION dolfin LOCATION)
get_filename_component(DOLFIN_LIBRARY_FILENAME ${DOLFIN_LIBRARY_LOCATION} NAME)
set(DOLFIN_LIBRARY "${CMAKE_INSTALL_PREFIX}/${DOLFIN_LIB_DIR}/${DOLFIN_LIBRARY_FILENAME}")

configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin-config.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/dolfin-config.cmake @ONLY)
configure_file(${DOLFIN_CMAKE_DIR}/templates/dolfin-config-version.cmake.in
  ${CMAKE_BINARY_DIR}/dolfin/dolfin-config-version.cmake @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/dolfin/dolfin-config.cmake
    ${CMAKE_BINARY_DIR}/dolfin/dolfin-config-version.cmake
  DESTINATION ${DOLFIN_SHARE_DIR}/cmake
  COMPONENT Development
  )

#------------------------------------------------------------------------------

## dolfin 1.0-beta

=== debian/changelog ===
dolfin (1.0-beta-1) unstable; urgency=low

  * New upstream release. This release fixes a large number of bugs and
    brings many improvements. The most notable changes are improved
    support for parallel computing and a redesigned and simplified
    interface for solving variational problems.
  * debian/control:
    - Add libboost-iostreams-dev to Build-Depends and to Depends in -dev
      package.
    - Replace libdolfin0 with libdolfin1.0 and libdolfin0-dev with
      libdolfin1.0-dev to follow library soname.
    - Bump required version for ufc, python-ufc, python-ffc,
      python-viper, python-ufl, and python-instant.
    - Add provide, replace and conflict on libdolfin0-dev for binary
      package libdolfin1.0-dev. Similarly for libdolfin1.0-dbg.
  * Add patch for importing PyTrilinos before dolfin (closes: #631589).
  * Rename libdolfin0.install to libdolfin1.0.install and
    libdolfin0-dev.install to libdolfin1.0-dev.install to follow library
    soname.

 -- Johannes Ring <johannr@simula.no>  Wed, 17 Aug 2011 12:01:58 +0200

=== debian/control ===
Source: dolfin
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.90~),
 debhelper (>= 7),
 python-all-dev (>= 2.6.6-3~),
 cmake (>= 2.8.0),
 swig2.0,
 python-numpy,
 pkg-config,
 libxml2-dev,
 libboost-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-iostreams-dev,
 libsuitesparse-dev,
 ufc (>= 2.0.2),
 python-ufc (>= 2.0.2),
 libptscotch-dev [!armel !mips !mipsel !s390 !sparc],
 libpetsc3.1-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
 libslepc3.1-dev [!armel !hurd-i386 !ia64 !mips !mipsel !s390 !sparc],
 libarmadillo-dev,
 libtrilinos-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc]
Standards-Version: 3.9.2
X-Python-Version: >= 2.5
Homepage: http://www.fenicsproject.org
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/dolfin/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/dolfin/trunk/

Package: libdolfin1.0-dev
Section: libdevel
Architecture: any
Depends: libdolfin1.0 (= ${binary:Version}),
 libxml2-dev,
 pkg-config,
 libboost-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-iostreams-dev,
 libsuitesparse-dev,
 libptscotch-dev [!armel !mips !mipsel !s390 !sparc],
 libpetsc3.1-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
 libslepc3.1-dev [!armel !hurd-i386 !ia64 !mips !mipsel !s390 !sparc],
 libarmadillo-dev,
 cmake (>= 2.8.0),
 libtrilinos-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
 ufc (>= 2.0.2),
 python-ufc (>= 2.0.2),
 ${misc:Depends}
Conflicts: libdolfin0-dev
Replaces: libdolfin0-dev
Provides: libdolfin0-dev
Description: Shared links and header files for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the development files.

Package: dolfin-dev
Section: libdevel
Architecture: all
Depends: libdolfin1.0-dev, ${misc:Depends}
Description: Empty package depending on latest DOLFIN development package
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package will always depend on the most recent version of libdolfinX-dev
 (X=version), so if you install it then you will get upgrades automatically.

Package: libdolfin1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: dolfin-doc, libdolfin1.0-dbg, python-dolfin
Description: shared libraries for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the shared libraries.

Package: libdolfin1.0-dbg
Section: debug
Architecture: any
Depends: libdolfin1.0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libdolfin0-dgb
Replaces: libdolfin0-dbg
Provides: libdolfin0-dbg
Description: Shared libraries with debugging symbols for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-dolfin
Section: python
Architecture: any
Depends: libdolfin1.0-dev (= ${binary:Version}),
 libdolfin1.0 (= ${binary:Version}),
 python-ufc (>= 2.0.2),
 python-ffc (>= 1.0-beta),
 python-viper (>= 1.0-beta),
 python-ufl (>= 1.0-beta2),
 python-instant (>= 1.0-beta),
 python-numpy,
 python-pytrilinos [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
 swig2.0,
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: dolfin-doc
Description: Python interface for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains the Python interface for DOLFIN.

Package: dolfin-doc
Architecture: all
Section: doc
Depends: libdolfin1.0-dev (>= ${source:Version}),
 python-dolfin (>= ${source:Version}),
 ${misc:Depends}
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends: python-dolfin (>= ${source:Version}),
 ${python:Depends},
 ${misc:Depends}
Description: Executable scripts for DOLFIN
 DOLFIN is the C++/Python interface of FEniCS, providing a consistent PSE
 (Problem Solving Environment) for ordinary and partial differential equations.
 .
 This package contains executable scripts for DOLFIN.

## dolfin 1.0-rc2

=== debian/changelog ===
dolfin (1.0-rc2-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Bump version for ufc and python-ufc to 2.0.4.

 -- Johannes Ring <johannr@simula.no>  Tue, 29 Nov 2011 11:44:52 +0100

dolfin (1.0-rc1-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Update Homepage field.
    - Add libboost-math-dev to Build-Depends and in Depends field for
      binary package libdolfin1.0-dev.
  * Disable Trilinos support (version >= 10.8.1 now required).
  * Remove patch for building with Trilinos.
  * Update debian/copyright and debian/copyright_hints.

 -- Johannes Ring <johannr@simula.no>  Tue, 22 Nov 2011 12:10:02 +0100

dolfin (1.0-beta2-1) unstable; urgency=low

  * New upstream release.
  * Add lintian override dolfin-dev: empty-binary-package.
  * debian/control:
    - Add libboost-mpi-dev in Build-Depends and in Depends field for
      binary package libdolfin1.0-dev.
    - Bump version numbers for dependencies ufc, python-ufc, python-ffc,
      and python-ufl.
  * debian/patches: Remove patch for importing PyTrilinos before DOLFIN
    as this is now fixed upstream.

 -- Johannes Ring <johannr@simula.no>  Thu, 27 Oct 2011 13:17:47 +0200

=== debian/control ===
--- 
+++ 
@@ -17,17 +17,18 @@
  libboost-serialization-dev,
  libboost-thread-dev,
  libboost-iostreams-dev,
+ libboost-mpi-dev,
+ libboost-math-dev,
  libsuitesparse-dev,
- ufc (>= 2.0.2),
- python-ufc (>= 2.0.2),
+ ufc (>= 2.0.4),
+ python-ufc (>= 2.0.4),
  libptscotch-dev [!armel !mips !mipsel !s390 !sparc],
  libpetsc3.1-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
  libslepc3.1-dev [!armel !hurd-i386 !ia64 !mips !mipsel !s390 !sparc],
- libarmadillo-dev,
- libtrilinos-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc]
+ libarmadillo-dev
 Standards-Version: 3.9.2
 X-Python-Version: >= 2.5
-Homepage: http://www.fenicsproject.org
+Homepage: http://fenicsproject.org
 DM-Upload-Allowed: yes
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/fenics/dolfin/trunk
 Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/fenics/dolfin/trunk/
@@ -44,15 +45,16 @@
  libboost-serialization-dev,
  libboost-thread-dev,
  libboost-iostreams-dev,
+ libboost-mpi-dev,
+ libboost-math-dev,
  libsuitesparse-dev,
  libptscotch-dev [!armel !mips !mipsel !s390 !sparc],
  libpetsc3.1-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
  libslepc3.1-dev [!armel !hurd-i386 !ia64 !mips !mipsel !s390 !sparc],
  libarmadillo-dev,
  cmake (>= 2.8.0),
- libtrilinos-dev [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
- ufc (>= 2.0.2),
- python-ufc (>= 2.0.2),
+ ufc (>= 2.0.4),
+ python-ufc (>= 2.0.4),
  ${misc:Depends}
 Conflicts: libdolfin0-dev
 Replaces: libdolfin0-dev
@@ -103,13 +105,12 @@
 Architecture: any
 Depends: libdolfin1.0-dev (= ${binary:Version}),
  libdolfin1.0 (= ${binary:Version}),
- python-ufc (>= 2.0.2),
- python-ffc (>= 1.0-beta),
+ python-ufc (>= 2.0.4),
+ python-ffc (>= 1.0-beta2),
  python-viper (>= 1.0-beta),
- python-ufl (>= 1.0-beta2),
+ python-ufl (>= 1.0-beta3),
  python-instant (>= 1.0-beta),
  python-numpy,
- python-pytrilinos [!armel !hurd-i386 !mips !mipsel !s390 !sparc],
  swig2.0,
  ${python:Depends},
  ${shlibs:Depends},
